<?php

###############################################################################
#                   ALLbum-0.1.0: sas_index.php                               #
#                    (English language file)                                  #
#                                                                             #
# ALLbum-0.1.0 is a development version of the ALLbum gallery.                #
# It is also available as a module for the Content Management System          #
# "Site@School"  (http://siteatschool.sourceforge.net).                       #
#                                                                             #
# ALLbum is hosted at http://sasmodulesi.sourceforge.net                      #
# ALLbum is written by Martin Herrman <m.herrman@student.tue.nl>              #
# ALLbum is copyrighted by OBS Rosa Boekdrukker, Amsterdam, The Netherlands   #
# (http://www.rosaboekdrukker.nl)                                             #
# ALLbum is licenced by GNU General Public Licence                            #
#                                                                             #
###############################################################################
#                                                                             #
#                            LICENCE INFORMATION                              #
#                                                                             #
# Copyright (c) 2003, OBS Rosa Boekdrukker, Amsterdam, The Netherlands.       #
#                                                                             #
# This program is free software, you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        #
# See the GNU General Public License for more details.                        #
#                                                                             #
# You should hvae received a copy of the GNU General Public License           #
# along with this program; if not, write to the Free Software                 #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. #
#                                                                             #
###############################################################################

#### Used by visitor ####

$lang['sn_allbum_object_hidden'] = "Object hidden";
$lang['sn_allbum_object_hidden_text'] = "This object is hidden.";

#### Used by maintainer ####

$lang['sn_allbum_menu'] = "Menu";
$lang['sn_allbum_main'] = "Main";
$lang['sn_allbum_create_album'] = "Create album";
$lang['sn_allbum_add_object'] = "Add object";
$lang['sn_allbum_configuration'] = "Configuration";
$lang['sn_allbum_are_you_sure'] = "Are you sure you want to delete the following items? ";
$lang['sn_allbum_not_empty'] = " The following items are NOT empty: ";
$lang['sn_allbum_edittitdesc'] = "Edit title / description";
$lang['sn_allbum_pleae_select'] = "Please select one or more items.";
$lang['sn_allbum_deleteselecteditems'] = "Delete selected items";
$lang['sn_allbum_return'] = "Return";
$lang['sn_allbum_title'] = "Title";
$lang['sn_allbum_description'] = "Description";
$lang['sn_allbum_cancel'] = "Cancel";
$lang['sn_allbum_save'] = "Save";
$lang['sn_allbum_non_fatal'] = "NON-FATAL ERROR: The title of the (sub-)album with old title ";
$lang['sn_allbum_cannot'] = " cannot be changed into title ";
$lang['sn_allbum_because'] = " because a (sub-)album with that title already exists within the current album.";
$lang['sn_allbum_check_error'] = "An error has occured. Please read all messages you see carefully. If you do not understand one of them, pleae ask your system administrator for help. If there are no fatal errors, click";
$lang['sn_allbum_here'] = " here ";
$lang['sn_allbum_to_proceed'] = "to proceed.";
$lang['sn_allbum_error_redirect'] = "No errors detected. You will be redirected as soon as possible. If that does not happen, your browser does not support javascript. Please click the main link in the menu manually.";
$lang['sn_allbum_options'] = "Options:";
$lang['sn_allbum_hide'] = "hide object";
$lang['sn_allbum_unhide'] = "unhide object";
$lang['sn_allbum_select_item'] = "Select object";
$lang['sn_allbum_deselect_item'] = "Deselect object";
$lang['sn_allbum_album_exists'] = "Album exists";
$lang['sn_allbum_album_exists_text'] = "The album you want to create already exists. Please try again with a unique title.";
$lang['sn_allbum_err'] = "ERROR: ";
$lang['sn_allbum_create_error'] = "An error occured during album creation. This probably means something is wrong with the database, or the directory (owner/rights/disk full). Other error messages on your current screen might help. Please contact your system administrator if you do not understand what caused the error.";
$lang['sn_allbum_error_create_sub_album'] = "ERROR creating (sub-)album directory on harddisk!";
$lang['sn_allbum_files'] = "Add the following file(s)";
$lang['sn_allbum_or_select_files'] = "Or select files from the server's media directory:";
$lang['sn_allbum_add_objects'] = "Add object(s)";
$lang['sn_allbum_add_object_error'] = "ERROR";
$lang['sn_allbum_add_object_error_text'] = "An error occured while uploading a file. Please read any error message carefully; if you do not understand one of the error messages, please aks your system administrator for help.";
$lang['sn_allbum_database_error'] = "An error occured using the database.";
$lang['sn_allbum_file_copy_error'] = "An error occured copying a file.";
$lang['sn_allbum_file_copy_error_media'] = "An error occured copying a file. Maybe an object with the same file-name already exists in the (sub-)album, or there is no free space available.";
$lang['sn_allbum_file_upload_error'] = "An error occured while uploading a file.";
$lang['sn_allbum_error0'] = "No error.";
$lang['sn_allbum_error1'] = "Error: The file you tried to upload is too large.";
$lang['sn_allbum_error2'] = "Error: The file you tried to upload is too large.";
$lang['sn_allbum_error3'] = "Error: The file you tried to upload has been uploaded partially.";
$lang['sn_allbum_error4'] = "Error: No file has been uploaded.";
$lang['sn_allbum_error9'] = "Error: An object with the same file-name does already exist in the (sub-)album.";
$lang['sn_allbum_error'] = "Error: There was an unknown error.";
$lang['sn_allbum_allbum_thumbsize_x'] = "Horizontal size of thumbnails (px)";
$lang['sn_allbum_allbum_picsize_x'] = "Horizontal size of pictures (px)";
$lang['sn_allbum_allbum_max_objects_per_page'] = "Maximal number of objects shown per page";
$lang['sn_allbum_allbum_num_files'] = "Maximal number of objects that can be added at once";
$lang['sn_allbum_allbum_num_objects_per_row'] = "Number of objects shown per row";
$lang['sn_allbum_save_configuration'] = "Save configuration";
$lang['sn_allbum_configuration_saved'] = "Configuration saved";
$lang['sn_allbum_configuration_saved_text'] = "The configuration was saved succesfully.";
$lang['sn_allbum_please_select'] = "Please select one or more objects first.";
$lang['sn_allbum_description_1000'] = "The description you entered has more than 1000 characters. Please correct and try again.";
$lang['sn_allbum_title_illegal'] = "You have used an illegal character in the title of the (sub-)album. Illegal characters are:<BR><BR>[ ] > < & % $ \" ' `<BR><BR>Please correct and try again.";
$lang['sn_allbum_title_like_dir'] = "You have used \".\" or \"..\" as a title. Those titles are not allowed. Please choose a different title name.";
$lang['sn_allbum_object_with_title'] = "The object with new title ";
$lang['sn_allbum_is_or'] = " is . or .. ";
$lang['sn_allbum_contains_illegal'] = " contains an illegal character ";
$lang['sn_allbum_has_description'] = " has a description consisting of more than 1000 characters ";
$lang['sn_allbum_which_is_not'] = "which is not allowed. Please correct and try to save the changes again.";
$lang['sn_allbum_move_selected'] = "Move selected items";
$lang['sn_allbum_move_heading'] = "Move objects";
$lang['sn_allbum_move_text'] = "The following objects will be moved (albums can not be moved):";
$lang['sn_allbum_move_text2'] = "Please select their destination:";
$lang['sn_allbum_move'] = "Move";
$lang['sn_allbum_move_error'] = "ERROR";
$lang['sn_allbum_move_error_text'] = "An error occured while moving the selected objects. All objects processed before the object that caused the error have been processed succesfully. When the error occured, no more actions have been taken. Please read the following error message:";
$lang['sn_allbum_move_file_error'] = "An error occured while moving a file.";
$lang['sn_allbum_move_file_error_exists'] = "An error occured while moving a file. An object with the same file-name already exists in the destination album.";
$lang['sn_allbum_move_dir_error'] = "An error occured while moving a directory.";
$lang['sn_allbum_move_not_main'] = "It is not allowed to move objects to a main page. Please first create a main album and move the desired objects to this main album.";
$lang['sn_allbum_move_empty'] = "You have selected (sub-)albums only. (Sub-)albums can not be moved.";
$lang['sn_allbum_toggle'] = "(De)select all";
$lang['sn_allbum_select_all'] = "Select all";
$lang['sn_allbum_deselect_all'] = "Deselect all";
$lang['sn_allbum_order_album'] = "Order sub-album";
$lang['sn_allbum_order_album_text'] = "Please select the desired order below.";
$lang['sn_allbum_order'] = "Order";
$lang['sn_allbum_order_objects'] = "Order items";
$lang['sn_allbum_order_invalid'] = "The order you have entered is invalid. Be sure every object has a unique number.";

#### Used by both ####

$lang['sn_allbum_next_page'] = "Next page";
$lang['sn_allbum_previous_page'] = "Previous page";
$lang['sn_allbum_next_object'] = "Next object";
$lang['sn_allbum_previous_object'] = "Previous object";
$lang['sn_allbum_empty_album'] = "This (sub-)album does not contain any objects.";
$lang['sn_allbum_album'] = "Album";
$lang['sn_allbum_gallery_main_page'] = "ALLbum Main Page";
$lang['sn_allbum_no_main_albums_avail'] = "No main albums available.";
$lang['sn_allbum_return_to'] = "Return to: ";
$lang['sn_allbum_download_file'] = "Download file";

?>
