<?php


###############################################################################
#                    ALLbum-0.1.0: sas_admin.php                              #
#                (SAS maintainer interface component)                         #
#                                                                             #
# ALLbum-0.1.0 is a development version of the ALLbum gallery.                #
# It is also available as a module for the Content Management System          #
# "Site@School"  (http://siteatschool.sourceforge.net).                       #
#                                                                             #
# ALLbum is hosted at http://sasmodulesi.sourceforge.net                      #
# ALLbum is written by Martin Herrman <m.herrman@student.tue.nl>              #
# ALLbum is copyrighted by OBS Rosa Boekdrukker, Amsterdam, The Netherlands   #
# (http://www.rosaboekdrukker.nl)                                             #
# ALLbum is licenced by GNU General Public Licence                            #
#                                                                             #
###############################################################################
#                                                                             #
#                            LICENCE INFORMATION                              #
#                                                                             #
# Copyright (c) 2003, OBS Rosa Boekdrukker, Amsterdam, The Netherlands.       #
#                                                                             #
# This program is free software, you can redistribute it and/or               #
# modify it under the terms of the GNU General Public License                 #
# as published by the Free Software Foundation; either version 2              #
# of the License, or (at your option) any later version.                      #
#                                                                             #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY; without even the implied warranty of              #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        #
# See the GNU General Public License for more details.                        #
#                                                                             #
# You should hvae received a copy of the GNU General Public License           #
# along with this program; if not, write to the Free Software                 #
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. #
#                                                                             #
###############################################################################

// use language file:
if(file_exists($serverpath . "/languages/$language/sn_allbum/$language.php")) {
	include($serverpath . "/languages/$language/sn_allbum/$language.php");
} else {
	include($serverpath . "/languages/EN/sn_allbum/EN.php");
}

include("db_functions.inc.php");

include($serverpath. "/interface/header.inc.php");
include($serverpath. "/interface/menubar.inc.php");
include($serverpath. "/interface/menustart.inc.php");
	
// what should we do? :
if (IsSet($_GET[suboption2])) {
    if ($_GET[suboption2] == hide) {
	db_PutHideObject($_GET[ID2]);
    } elseif ($_GET[suboption2] == unhide) {
	db_PutUnhideObject($_GET[ID2]);
    } elseif ($_GET[suboption2] == select) {
        // skip
    } elseif ($_GET[suboption2] == delete) {
        db_PutDeleteObjects($_GET[ID3]);
	$_GET[suboption2] = "";
	$_GET[ID3] = "";
    }
    $_GET[suboption] = show;
}
if ($_GET[suboption] == show) {
	if( IsSet($_GET[ID]) AND IsSet($_GET[gallerypage]) ) {
		if ($_GET[ID] != 0) {
		  $type = db_GetType($_GET[ID]);
		  if ( ($type == 'album') or ($type == 'subalbum') ) {
			ShowMenu(1,1,1,1,1,1,1);
		  } else {
			ShowMenu(1,0,0,1,0,0,0);
		  }
		} else {
		    ShowMenu(1,1,0,1,1,1,1);
		}
		include($serverpath. "/interface/menuend.inc.php");
		include($serverpath. "/interface/pagestart.inc.php");
		ShowContent($_GET[ID], $_GET[gallerypage]);
	} else {
		ShowMenu(1,1,0,1,1,1,1);
		include($serverpath. "/interface/menuend.inc.php");
		include($serverpath. "/interface/pagestart.inc.php");
		ShowContent(0, 1);
	}
} elseif ($_GET[suboption] == config) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowConfig();
} elseif ($_GET[suboption] == createalbum) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowCreateAlbum();
} elseif ($_GET[suboption] == addobject) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowAddObject();
} elseif ($_GET[suboption] == edit) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowEdit();
} elseif ($_GET[suboption] == ordersub) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowOrderSub();
} elseif ($_GET[suboption] == ordermain) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowOrderMain();
} elseif ($_GET[suboption] == move) {
	ShowMenu(1,0,0,0,0,0,0);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowMove();
} else {
	ShowMenu(1,1,0,1,1,1,1);
	include($serverpath. "/interface/menuend.inc.php");
	include($serverpath. "/interface/pagestart.inc.php");
	ShowContent(0,1);
}

include("interface/pageend.inc.php");
include("interface/footer.inc.php");

function ShowMenu($main, $add_album, $add_object, $configuration, $editmovedelete, $selectall, $order)
{
  global $lang;
  global $module;
  global $ID;
  global $ID3;
  global $navpath;
  echo "<span class=\"heading\">" .$lang[sn_allbum_menu]. "</span><BR><BR>";
  if ($main == 1) {
    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show\">" .$lang[sn_allbum_main]. "</a></span><BR>";
  }
  if ($add_album == 1) {
    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=" .$module. "&navpath=".$_GET[navpath]."&suboption=createalbum&ID=" .$_GET[ID]. "\">" .$lang[sn_allbum_create_album]. "</a></span><BR>";
  }
  if ($add_object == 1) {
    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=" .$module. "&navpath=".$_GET[navpath]."&suboption=addobject&ID=" .$_GET[ID]. "\">" .$lang[sn_allbum_add_object]. "</a></span><BR>";
  }
  if ($selectall == 1) {
    // Show (de)select all option:
    if (IsSet($_GET[gallerypage])) {
	$page2 = $_GET[gallerypage];
    } else {
	$page2 = 1;
    }
    if (IsSet($_GET[ID])) {
	$id2 = $_GET[ID];
    } else {
	$id2 = 0;
    }
    $contents2 = db_GetContents($id2);
    $items2 = array();
    $max_objects_per_page = db_GetMaxObjectsPerPage();
    $num = count($contents2);

    for ( 
	    $i = (($page2-1) * $max_objects_per_page)+1;
	    ($i <= ($page2 * $max_objects_per_page)) AND ($i <= $num);
	    $i++
	)
    {
	array_push($items2,$contents2[$i-1]);
    }

    $items2string = implode(",",$items2);
    
    $selectedstring = $_GET[ID3];
    if ($selectedstring == "") {
	$selectedarray = array();
    } else {
	$selectedarray = explode(",",$selectedstring);
        $selectedarray = array_clean($selectedarray,"");
    }
    
    if ( count($selectedarray) == count($items2) ) {
	echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=show&ID=".$id2."&ID3=&gallerypage=".$page2."\">".$lang[sn_allbum_deselect_all]."</a></span><BR>";
    } else {
	echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=show&ID=".$id2."&ID3=".$items2string."&gallerypage=".$page2."\">".$lang[sn_allbum_select_all]."</a></span><BR>";
    }

  }
  if ($order == 1) {
	// show order option:
	if ( (IsSet($_GET[ID])) AND ($_GET[ID] != "") AND ($_GET[ID] > "0") ) {
	    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=ordersub&ID=".$_GET[ID]."&gallerypage=".$_GET[gallerypage]."\">".$lang[sn_allbum_order_objects]."</a></span><BR>";
	} else {
	    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=ordermain&ID=".$_GET[ID]."&gallerypage=".$_GET[gallerypage]."\">".$lang[sn_allbum_order_objects]."</a></span><BR>";
	}
  }
  if ($editmovedelete == 1) {
  	    // Show edit / move / delete option:
	    
	    // Get titlename and "empty or not" for all selected items:
	    $items = explode(",",$_GET[ID3]);
	    $items2dim = array();
	    foreach ($items AS $key => $value) {
	        if ($value != "") {
		    $items2dim[$key][0] = db_GetTitle($value);
		    $items2dim[$key][1] = db_GetEmpty($value);
		}
	    }
	    
	    // make warning message text:
	    $message = $lang[sn_allbum_are_you_sure] . "\\n";
	    foreach ($items2dim AS $key => $value) {
		$message = $message . " " . $value[0] . "\\n";
	    }
	    $i = 0;
	    foreach ($items2dim AS $key => $value) {
		if ($value[1] == "no") {
		    if ($i == 0) {
			$message = $message . $lang[sn_allbum_not_empty] . "\\n";
			$i++;
		    }
		    $message = $message . " " .$value[0] . "\\n";
		}
	    }
	    
	    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=edit&ID=".$_GET[ID]."&ID3=".$_GET[ID3]."&gallerypage=".$_GET[gallerypage]."\">".$lang[sn_allbum_edittitdesc]."</a></span><BR>";
	    if ($message == $lang[sn_allbum_are_you_sure] . "\\n") {
		echo "<span class=\"text\"><a href=\"javascript: void(0)\" OnClick='alert(\"".$lang[sn_allbum_please_select]."\")'\">".$lang[sn_allbum_move_selected]."</a></span><BR>";	    
		echo "<span class=\"text\"><a href=\"javascript: void(0)\" OnClick='alert(\"".$lang[sn_allbum_please_select]."\")'\">".$lang[sn_allbum_deleteselecteditems]."</a></span><BR>";	    
	    } else {
		echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=move&ID=".$_GET[ID]."&ID3=".$_GET[ID3]."&gallerypage=".$_GET[gallerypage]."\">".$lang[sn_allbum_move_selected]."</a></span><BR>";
		echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$_GET[navpath]."&suboption=show&suboption2=delete&ID3=".$_GET[ID3]."&ID=".$_GET[ID]."&gallerypage=".$_GET[gallerypage]."\" OnClick=\"return confirm('$message')\">".$lang[sn_allbum_deleteselecteditems]."</a></span><BR>";
	    }
  } if ($configuration == 1) {
    echo "<span class=\"text\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=config\">" .$lang[sn_allbum_configuration]. "</a></span><BR>";
  }
  
}

function ShowEdit()
{
    // Task: show a page with on each row a thumbnail and edit title/description
    // field. At the bottom a save and cancel button. Show objects on $_GET[ID]
    // and $_GET[gallerypage], if one of them is empty or not set, show first
    // main page contents. If one or more objects are selected, show only the
    // selected objects.
    
    global $ID;
    global $gallerypage;
    global $lang;
    global $module;
    global $content;
    global $ID3;
    global $navpath;

    // in case ID and Gallerypage are not set, make sure contents on first main page
    // is shown:
    if ((!IsSet($_GET[ID])) OR ($_GET[ID] == "")) {
	$_GET[ID] = 0;
	$_GET[gallerypage] = 1;
    }
    
    // If items are selected, show only these selected items:
    if ( (IsSet($_GET[ID3])) AND ($_GET[ID3] != "") AND ($_GET[ID3] != ",") ) {
	$contents = explode(",",$_GET[ID3]);
	$contents = array_clean($contents,"");
    } else {
	// Get list of $ID's contents:
	$contents = db_GetContents($_GET[ID]);
    }

    // If new titles and descriptions are entered, verify them for correctness:
    if (IsSet($_GET[content])) {
    	// Get all changed object ID's:
	$content = explode("X",$_GET[content]);
	array_pop($content);	
	// Verify them:
	$verified = array("ok","","");
	foreach ($content AS $key => $value) {
	    // get new title and description:
	    $titleget = $value . "title";
	    $descget = $value . "description";
	    global ${$titleget};
	    global ${$descget};
	    $newtitle = $_GET[$titleget];
	    $newdescription = $_GET[$descget];
	    if (($newtitle == ".") OR ($newtitle == "..")) {
		$verified[0] = "nok";
		$verified[1] = $newtitle;
		$verified[2] = "dirtitle";
		break;
	    } elseif (illegal_chars($newtitle)) {
		$verified[0] = "nok";
		$verified[1] = $newtitle;
		$verified[2] = "chartitle";
		break;
	    } elseif (strlen($newdescription) > 1000) {
		$verified[0] = "nok";
		$verified[1] = $newtitle;
		$verified[2] = "lendesc";
		break;	    
	    }
	}	    
    }
    
    // Check if the list is empty:
    if (!IsSet($contents[0])) {

	echo "<form action=\"index.php\" method=\"get\">";

	echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
	echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"show\">";
    	echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">";
	echo "<INPUT type=\"hidden\" name=\"navpath\" value=\"".$_GET[navpath]."\">";
    	echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"".$_GET[gallerypage]."\">";

	echo "<table>";
	echo "<tr><td colspan=\"2\"><p><span class=\"text\">" .$lang[sn_allbum_empty_album]. "</span></p></td></tr>";
	echo "<tr><td colspan=\"2\"><p><BR><span class=\"text\"><INPUT type=\"submit\" value=\"".$lang[sn_allbum_return]."\"</span></p></td></tr>";
	echo "</table>";

    } elseif (!IsSet($_GET[content]) OR ($verified[0] == "nok")) {
		
	// Calculate which children should be shown on page $_GET[gallerypage]:
	$num = count($contents);
	$show = array();
	$max_objects_per_page = db_GetMaxObjectsPerPage();
	for ( 
	    $i = (($_GET[gallerypage]-1) * $max_objects_per_page)+1;
	    ($i <= ($_GET[gallerypage] * $max_objects_per_page)) AND ($i <= $num);
	    $i++
	)
	{
	    array_push($show,$contents[$i-1]);
	}
	
	// heading:
	echo "<p><span class=\"heading\">".$lang[sn_allbum_edittitdesc]."</span></p>";

	// Show error message if applicable:
	if ($verified[0] == "nok") {
	    echo "<p><span class=\"text\">".$lang[sn_allbum_object_with_title].$verified[1];
	    if ($verified[2] == "dirtitle") {
		echo $lang[sn_allbum_is_or];
	    } elseif ($verified[2] == "chartitle") {
		echo $lang[sn_allbum_contains_illegal];
	    } elseif ($verified[2] == "lendesc") {
		echo $lang[sn_allbum_has_description];
	    }
	    echo $lang[sn_allbum_which_is_not]."</span></p>";
	}

	// start form:
	echo "<form action=\"index.php\" method=\"get\">";

	$content = "";
	foreach($show AS $key => $value) {
	    $content = $content . $value . "X";
	}

	echo "<INPUT type=\"hidden\" name=\"content\" value=\"".$content."\">";
	echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
	echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"edit\">";
    	echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">";
	echo "<INPUT type=\"hidden\" name=\"ID3\" value=\"".$_GET[ID3]."\">";
	echo "<INPUT type=\"hidden\" name=\"navpath\" value=\"".$_GET[navpath]."\">";
    	echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"".$_GET[gallerypage]."\">";

	// start table:
	echo "<table>";
	
	// horizontal line:
	echo "<tr><td align=\"center\" colspan=\"3\"><HR width=\"95%\"></td></tr>";
	
	// Show each object:
	$x = db_GetThumbSizeX();
	foreach($show AS $key => $value) {
	
	    // Start row:
	    echo "<tr>";
	    
	    // Get all details array[type, title, description, path, thumb, obj, org, hidden] for first object:
	    $details = db_GetAllDetails($value);
	    if (ThumbIsIcon($details[4])) {
		$path = $details[4];
	    } else {
		$path = str_replace("//","/",$details[3]."/".$details[4]);
	    }
	    
	    // Show object:
	    echo "<td rowspan=\"2\" align=\"center\">
	             <img src=\"" .$path. "\" width=\"" .$x. "\">
		  <p><span class=\"text\">";
		    if (($details[0] == "subalbum") OR ($details[0] == "album")) {
		    	echo "<STRONG>".$lang[sn_allbum_album]."</STRONG>";
		    } else {
			echo "&nbsp;";
		    }
		echo "</span>
		 </p>
	      </td>";

	    // Show edit fields:
	    echo "<td valign=\"top\">";
	    if (IsSet($verified)) {
		$titleget = $value . "title";
		$descget = $value . "description";
		global ${$titleget};
		global ${$descget};
		$showntitle = $_GET[$titleget];
		$showndescription = stripslashes($_GET[$descget]);
	    } else {
		$showntitle = $details[1];
    		$showndescription = $details[2];
	    }
	    echo $lang[sn_allbum_title].": </td><td valign=\"top\"><TEXTAREA name=\"".$value."title\" cols=\"50\" rows=\"1\">".$showntitle."</TEXTAREA>
	          </td><tr><td valign=\"top\">
		  ".$lang[sn_allbum_description].": </td><td valign=\"top\"><TEXTAREA name=\"".$value."description\" cols=\"50\" rows=\"5\">".$showndescription. "</TEXTAREA>";
	    echo "</td></tr>";
	      
	    // close row:
	    echo "</tr>";
	      
	     // Show horizontal line:
	    echo "<tr><td align=\"center\" colspan=\"3\"><HR width=\"95%\"></td></tr>";
	    
	}
	
	// show save and cancel button:
	echo "<tr><td align=\"center\" colspan=\"3\">
	    <p><span class=\"text\">
	    <INPUT type=\"button\" value=\"".$lang[sn_allbum_cancel]."\" OnClick=\"window.location='index.php?option=modulemanager&module=".$module."&suboption=show&ID=".$_GET[ID]."&navpath=".$_GET[navpath]."&gallerypage=".$_GET[gallerypage]."';\">
	    &nbsp;<INPUT type=\"submit\" value=\"".$lang[sn_allbum_save]."\">
	    </span></p>
	    </td></tr>";
	
	// close table:
	echo "</table>";

	// end form:
	echo "</form>";
    } else {
    
	// $_GET[content] has been set and does not contain any illegal things,
	// now update all titles and descriptions.
	
	// Get all changed object ID's:
	$content = explode("X",$_GET[content]);
	array_pop($content);
	
	// update each object:
	$check = "ok";
	foreach ($content AS $key => $value) {
	    // get new and old title and description:
	    $titleget = $value . "title";
	    $descget = $value . "description";
	    global ${$titleget};
	    global ${$descget};
	    $oldtitle = db_GetTitle($value);
	    $newtitle = $_GET[$titleget];
	    
	    // seperate (sub-) albums from other objects:
	    $type = db_GetType($value);
	    if (($type == 'album') OR ($type == 'subalbum')) {
		
		// *(sub-)album*
		
		// check if new title doesn't already exist:
		if ($_GET[ID] == 0) {
		    $a = -1;
		} else {
		    $a = $_GET[ID];	
		}
		if ((db_GetAlbumExists($_GET[$titleget], $a) === true) AND ($oldtitle != $newtitle)) {
		    $check == "nok";
		    echo $lang[sn_allbum_non_fatal].$oldtitle.$lang[sn_allbum_cannot].$newtitle.$lang[sn_allbum_because];
		    continue;
		} else {
		    // rename directory
		    $olddir = db_GetPath($value);
		    $newdir = explode("/", $olddir);
		    array_pop($newdir);
		    array_push($newdir, $_GET[$titleget]);
		    $newdir = implode("/",$newdir);
		    $succes = rename($olddir,$newdir);
		    if ($succes === false) {
			$check = "nok";
			break;
		    }
		    
		    // update database entries:
		    // - own title and description
		    $check = db_PutTitleDescriptionObject($value,$_GET[$titleget],$_GET[$descget]);
		    if ($check == "nok") {
			break;
		    }
		    
		    // - own path
		    $check = db_PutPathObject($value,$newdir);
		    if ($check == "nok") {
			break;
		    }
		    
		    // update children (recursive) database entries (path)
		    $level = db_GetLevel($value);
		    $check = db_PutChildrenPath($value,$_GET[$titleget],$level,$type);
		    if ($check == "nok") {
			break;
		    }
		    
		    // if available, update parents:
		    if ($type != "album") {
			$check = db_PutParentsPath($value,$_GET[$titleget],0,$type);
			if ($check == "nok") {
			    break;
			}
		    }
		    
		}
	    } else {

		// *other object type*

		// update own entry:
		$check = db_PutTitleDescriptionObject($value,$_GET[$titleget],$_GET[$descget]);
		if ($check == "nok") {
		    break;
		}
	    }
	    
	}
	
        if ($check == "nok") {
	    // show error message
	    echo $lang[sn_allbum_check_error]."<a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&navpath=".$_GET[navpath]."&ID=" .$_GET[ID]. "&gallerypage=1\" target=\"_self\">".$lang[sn_allbum_here]."</a>".$lang[sn_allbum_to_proceed];
	} else {
	    // javascript to reload page
	    echo $lang[sn_allbum_no_errors];
	    echo "<script language='javascript'>
	      window.location = 'index.php?option=modulemanager&module=" .$module. "&suboption=show&navpath=".$_GET[navpath]."&ID=" .$_GET[ID]. "&gallerypage=".$_GET[gallerypage]."'
	      </script>";
	    echo $lang[sn_allbum_error_redirect];
	}
    }
}

function ShowContent($ID, $gpage)
{
     
    // Task: show object with ID $ID except when $ID = 0, then a main page
    // should be shown;
    // When $ID is not a (sub-)album or a main page, $page is -1. Otherwise,
    // $page is the page number that should be shown.
    
    global $lang;
    global $module;
    global $navpath;

    // Get all details:
    // array[type, title, description, path, thumb, obj, org, hidden]
    $details = db_GetAllDetails($ID);

    $objects = array('sound', 'movie', 'doc', 'unknown');
    
    if (in_array($details[0], $objects)) {
    
    	// **sound-file, movie-file, document-file, unknown-file**
	
	// calculate next and previous picture:
	$albumcontents = array_clean(explode(",",$_GET[contents]),"");
	$i = 0;
	while ($albumcontents[$i] != $ID) {
		$i++;
	}
	if ($i == count($albumcontents)-1) {
	    $nextobjectid = $albumcontents[0];
	} else {
	    $nextobjectid = $albumcontents[$i+1];
	}
	if ($i == 0) {
	    $prevobjectid = $albumcontents[count($albumcontents)-1];
	} else {
	    $prevobjectid = $albumcontents[$i-1];
	}

	// Show navigation bar:
	ShowNavPath($_GET[navpath]);

	// Show page (title, image, description, navigation buttons):
	$iconpath = $details[4];
	$filepath = str_replace("//","/",$details[3]."/".$details[5]);
	echo "<table width=\"95%\" align=\"center\" border=\"0\">";
	echo "<tr>";
	echo "<td align=\"center\">";
	echo "<a href=\"index.php?option=modulemanager&suboption=show&module=".$module."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&ID=".$prevobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_previous_object]."\" src=\"modules/sn_allbum/nav_prev_icon.gif\"></a>";
	echo "</td><td align=\"center\" width=\"".$width."\">";
	echo "	<p><span class=\"heading\">" .$details[1]. "</span></p>";
	echo "  <img src=\"". $iconpath ."\">";
	echo "  <div align=\"center\"><p><span class=\"link\"><a href=\"".$filepath."\">" .$lang[sn_allbum_download_file]. "</a></span></p></div>";
	echo "  <div align=\"left\"><p><span class=\"text\">" .$details[2]. "</span></p></div>";
	echo "</td><td align=\"center\">";
	echo "<a href=\"index.php?option=modulemanager&suboption=show&module=".$module."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&ID=".$nextobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_next_object]."\" src=\"modules/sn_allbum/nav_next_icon.gif\"></a>";
	echo "</td>";
	echo "</tr></table>";
	
	// Show options
	echo "<p><span class=\"text\">" .$lang[sn_allbum_options]. "</span></p>";
	if ($details[7] == 0) {
	    echo "<p><span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&suboption2=hide&ID=" .$ID. "&ID2=" .$ID. "&gallerypage=-1\">" .$lang[sn_allbum_hide]. "</a></span></p>";
	} else {
	    echo "<p><span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&suboption2=unhide&ID=" .$ID. "&ID2=" .$ID. "&gallerypage=-1\">" .$lang[sn_allbum_unhide]. "</a></span></p>";
	}
	
	return 0;
    }

    
    $objects = array('picture');
    
    if (in_array($details[0], $objects)) {
    
    	// **picture**
	
	// Get object size options:
	$width = db_GetPicSizeX();

	// calculate next and previous picture:
	$albumcontents = array_clean(explode(",",$_GET[contents]),"");
	$i = 0;
	while ($albumcontents[$i] != $ID) {
		$i++;
	}
	if ($i == count($albumcontents)-1) {
	    $nextobjectid = $albumcontents[0];
	} else {
	    $nextobjectid = $albumcontents[$i+1];
	}
	if ($i == 0) {
	    $prevobjectid = $albumcontents[count($albumcontents)-1];
	} else {
	    $prevobjectid = $albumcontents[$i-1];
	}

	// Show navigation bar:
	ShowNavPath($_GET[navpath]);

	// Calculate width:
	$image = str_replace("//","/",$details[3]."/".$details[5]);
	$size = getimagesize($image);
	if ($size[0] < $size[1]) {
	    // portrait
	    $width = $width / 1.3;
	} else {
	    // landscape
	    // skip
	}
	
	// Show page (title, image, description, navigation buttons):
	echo "<table width=\"95%\" align=\"center\" border=\"0\">";
	echo "<tr>";
	echo "<td align=\"center\">";
	echo "<a href=\"index.php?option=modulemanager&suboption=show&module=".$module."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&ID=".$prevobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_previous_object]."\" src=\"modules/sn_allbum/nav_prev_icon.gif\"></a>";
	echo "</td><td align=\"center\" width=\"".$width."\">";
	echo "	<p><span class=\"heading\">" .$details[1]. "</span></p>";
	echo "  <img width=\"" .$width. "\" src=\"". $image ."\">";
	echo "  <div align=\"left\"><p><span class=\"text\">" .$details[2]. "</span></p></div>";
	echo "</td><td align=\"center\">";
	echo "<a href=\"index.php?option=modulemanager&suboption=show&module=".$module."&navpath=".$_GET[navpath]."&contents=".$_GET[contents]."&ID=".$nextobjectid."&gallerypage=1\"><img border=\"0\" title=\"".$lang[sn_allbum_next_object]."\" src=\"modules/sn_allbum/nav_next_icon.gif\"></a>";
	echo "</td>";
	echo "</tr></table>";
	
	// Show options
	echo "<p><span class=\"text\">" .$lang[sn_allbum_options]. "</span></p>";
	if ($details[7] == 0) {
	    echo "<p><span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&suboption2=hide&ID=" .$ID. "&ID2=" .$ID. "&gallerypage=-1\">" .$lang[sn_allbum_hide]. "</a></span></p>";
	} else {
	    echo "<p><span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&suboption2=unhide&ID=" .$ID. "&ID2=" .$ID. "&gallerypage=-1\">" .$lang[sn_allbum_unhide]. "</a></span></p>";
	}
	
	return 0;
    }
	
    $objects = array('album', 'subalbum');
	
    if (in_array($details[0],$objects)) {

	// **(sub-)album**

	// Show navigation bar:
	ShowNavPath($_GET[navpath]);

	// Show title:
	echo "<p><span class=\"heading\">" .$details[1]. "</span></p>";

	// Show description:
	echo "<p><span class=\"text\">" .$details[2]. "</span></p>";

	    // Get number of objects per row:
	    $numperrow = db_GetNumObjectsRow();
	
	// Start table:
	echo "<table align=\"center\" width=\"98%\">
	 <tr>
	    <td colspan=\"".$numperrow."\" align=\"center\"><HR width=\"95%\"></td>
	 </tr>";

	// Get list of $ID's contents:
	$contents = db_GetContents($ID);

	// Check if the list of children is empty:
	$num = count($contents);
	if ($num == 0) {
	    echo "<form action=\"index.php\" method=\"get\">";

	    echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	    echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
	    echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"show\">";
	    if (db_GetType($_GET[ID]) != "album") {
    		echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".db_GetParentID($_GET[ID])."\">";
	    } else {
		echo "<INPUT type=\"hidden\" name=\"ID\" value=\"0\">";
	    }
    	    echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"1\">";

	    echo "<tr><td colspan=\"".$numperrow."\"><p><span class=\"text\">" .$lang[sn_allbum_empty_album]. "</span></p></td></tr>";

	    echo "<tr><td colspan=\"".$numperrow."\"><p><BR><span class=\"text\"><INPUT type=\"submit\" value=\"".$lang[sn_allbum_return]."\"</span></p></td></tr>";
	    
	} else {
		
	    // Calculate which children should be shown on page $gpage:
	    $show = array();
	    $max_objects_per_page = db_GetMaxObjectsPerPage();
	    for ( 
		    $i = (($gpage-1) * $max_objects_per_page)+1;
		    ($i <= ($gpage * $max_objects_per_page)) AND ($i <= $num);
		    $i++
		)
	    {
		array_push($show,$contents[$i-1]);
	    }
	    
	    // make a ?-dimensional array of $show:
	    $showmultipledimensions = array_chunk($show,$numperrow);
	    
	    // Show each object:
	    $x = db_GetThumbSizeX();
	    foreach($showmultipledimensions AS $key => $value) {
	    
		// Start row:
		echo "<tr>";
	    
		// Show objects:
		$w = 100/$numperrow;
		for ($i = 0; $i < $numperrow; $i++) {
		    if (IsSet($value[$i])) {
			ShowObject($value[$i],$x,$w,$_GET[navpath].",".$ID,implode(",",$contents));
		    } else {
			echo "<td width=\"".$w."%\">&nbsp;</td>";
		    }
		}

		// End, start row:
		echo "</tr><tr>";

		for ($i = 0; $i < $numperrow; $i++) {
		    if (IsSet($value[$i])) {
			ShowObjectTitle($value[$i]);
		    } else {
			echo "<td>&nbsp;</td>";
		    }
		}

		
		// End row:
		echo "</tr>";
		
		// Start row:
		echo "<tr>";
		
		// Show (un)hide and (de)select links:
		for ($i = 0; $i < $numperrow; $i++) {
		    if (IsSet($value[$i])) {
			echo "<td width=\"".$w."%\" align=\"center\">"; 
		        ShowHide($value[$i],$ID,$_GET[ID3],$gpage);
			echo "<BR>";
			ShowSelect($value[$i],$ID,$_GET[ID3],$gpage);
			echo "</td>";
		    } else {
			echo "<td width=\"".$w."%\" align=\"center\">&nbsp;</td>";
		    }
		}

		// End row:
		echo "</tr>";
		
		// Show horizontal line:
		echo "<tr><td align=\"center\" colspan=\"".$numperrow."\"><HR width=\"95%\"></td></tr>";
	    }
	    
	    ShowPreviousNext($ID, $gpage, $num, $max_objects_per_page, $numperrow); 

	}
	
	// End table
	echo "</table>";
	
	return 0;
	
    } 
    
    if ($details[0] == 'main') {

	// **main-page**

        // show title:
        echo "<p><span class=\"heading\">" .$lang[sn_allbum_gallery_main_page]. "</span></p>";

        // start table:
        echo "<table width=\"98%\">
	        <tr>
	          <td align=\"center\" colspan=\"2\"><HR width=\"95%\"></td>
	        </tr>";
	      
	// Get list of main albums:
        $contents = db_GetContents($ID);
      
        // Check if list of main albums is empty:
	$num = count($contents);
        if ($num == 0) {
    	    echo "<tr><td colspan=\"2\"><p><span class=\"text\">" .$lang[sn_allbum_no_main_albums_avail]. "</span></p></td></tr>";
	} else {

            // sort $contents on value of parents field
	    $contents2 = array();
	    foreach($contents AS $key => $value) {
		$ordnum = db_GetParents($value);
		$contents2[$ordnum-1] = $value;
	    }
	    $contents = $contents2;

	    // Calculate which albums should be shown on page $page:
	    $show = array();
	    
	    $max_objects_per_page = db_GetMaxObjectsPerPage();
	    for ( 
		    $i = (($gpage-1) * $max_objects_per_page)+1;
		    ($i <= ($gpage * $max_objects_per_page)) AND ($i <= $num);
		    $i++
		)
	    {
		array_push($show,$contents[$i-1]);
	    }
	    
	    // Show each album:
	    $x1 = db_GetThumbSizeX();
	    foreach($show AS $key => $value) {
	    
		// Get album details (type, title, description, path, thumbfile):
		$details = db_GetSomeDetails($value);
		
		if (ThumbIsIcon($details[4])){
		    $path = $details[4];
		    $x2 = "";
		} else {
		    $path = str_replace("//","/",$details[3]."/".$details[4]);
		    $x2 = $x1;
		}
		
		// Show album:
		echo "<tr>
		        <td align=\"center\" width=\"40%\">
		         <a href=\"index.php?option=modulemanager&suboption=show&module=" .$module. "&ID=" .$value. "&gallerypage=1\">
			    <img src=\"" .$path. "\" width=\"" .$x2. "\">
			 </a>
			 </td>
			 <td width=\"60%\">
			 <p><span class=\"text\">
			      <STRONG>" .$details[1]. "</STRONG>
			      <BR><BR>
			      " .$details[2]. "
			    </span>
			 </p>
			 </td>
		      </tr>";
		      
		// Show hide/unhide link and select/deselect link:
		echo "<tr><td align=\"center\">";
		ShowHide($value,$ID,$_GET[ID3],$gpage);
		echo "<BR>";
		ShowSelect($value,$ID,$_GET[ID3],$gpage);
		echo "</td><td>&nbsp;</td>";
		echo "</tr>";
		
		// Show horizontal line:
		echo "<tr><td align=\"center\" colspan=\"2\"><HR width=\"95%\"></td></tr>";
	    }

	    ShowPreviousNext($ID, $gpage, $num, $max_objects_per_page, 2);

	}
	
	// End table:
        echo "</table>";
	
	return 0;
    }
} 

function ShowObject($id,$x,$w,$navpath,$contents)
{
  // Task: render thumbnail cell for object with id $ID within a row in a (sub)-album.

  global $module;
  global $lang;

  // Get some details array(type, title, description, path, thumbfile) for first object:
  $details = db_GetSomeDetails($id);

  if (ThumbIsIcon($details[4])) {
	$path = $details[4];
	$thumbicon = true;
  } else {
	$path = str_replace("//","/",$details[3]."/".$details[4]);
  }

  $size = getimagesize($path);
  if ($size[0] < $size[1]) {
    // portrait
    $x = $x/1.3;
  } else {
    // landscape
  }

  if ($thumbicon) {
    $x = "";
  }

  // Show object:
  echo "<td valign=\"center\" align=\"center\" width=\"".$w."%\">
	  <a href=\"index.php?option=modulemanager&suboption=show&contents=".$contents."&module=" .$module. "&navpath=".$navpath."&ID=" .$id. "&gallerypage=1\">
	    <img src=\"" .$path. "\" width=\"" .$x. "\">
	  </a>
	</td>";
}

function ShowObjectTitle($id)
{
  // Task: render title cell for object with id $ID within a row in a (sub)-album.

  global $lang;

  // Get some details array(type, title, description, path, thumbfile) for first object:
  $details = db_GetSomeDetails($id);

  // Show object title:
  echo "<td align=\"center\">
	  <p><span class=\"text\">";
	  if ($details[0] == "subalbum") {
		echo "<STRONG>Album: " .$details[1]. "</STRONG>";
	  } else {
		echo $details[1];
	  }
	  echo "</span>
	  </p>
	</td>";
}

function ShowHide($id,$parentid,$id3,$gpage)
{
  // Task: show hide/unhide link for object with id $id

  global $module;
  global $lang;
  global $navpath;

  if (db_GetHidden($id) == 0) {
	echo "<span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&suboption2=hide&navpath=".$_GET[navpath]."&ID=".$parentid. "&ID2=" .$id. "&ID3=" .$id3. "&gallerypage=" .$gpage."\">" .$lang[sn_allbum_hide]. "</a></span>";
  } else {
	echo "<span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=show&suboption2=unhide&navpath=".$_GET[navpath]."&ID=".$parentid. "&ID2=" .$id. "&ID3=" .$id3. "&gallerypage=" .$gpage."\">" .$lang[sn_allbum_unhide]. "</a></span>";
  }

}

function ShowSelect($id,$parentid,$id3,$gpage)
{
  // Task: show select/unselect link for object with id $id
  
  global $module;
  global $lang;
  global $navpath;
  
  if ( $id3 != "") {
  	$array = explode(",", $id3);
	if (in_array($id,$array)) {
		$array = array_clean($array,$id);
		if (IsSet($array[0])) {
			$array = implode(",", $array);
		} else {
		    	$array = "";
		}
		echo "<span class=\"link\"><a href=\"index.php?option=modulemanager&navpath=".$_GET[navpath]."&module=".$module."&suboption=show&suboption2=select&ID3=".$array."&ID=".$parentid."&gallerypage=".$gpage."\"><font color=\"orange\">".$lang[sn_allbum_deselect_item]."</font></a></span>";
	} else {
		echo "<span class=\"link\"><a href=\"index.php?option=modulemanager&navpath=".$_GET[navpath]."&module=".$module."&suboption=show&suboption2=select&ID3=".$id3.",".$id."&ID=".$parentid."&gallerypage=".$gpage."\">".$lang[sn_allbum_select_item]."</a></span>";
	}
  } else { 
	echo "<span class=\"link\"><a href=\"index.php?option=modulemanager&navpath=".$_GET[navpath]."&module=".$module."&suboption=show&suboption2=select&ID3=".$id3.",".$id."&ID=".$parentid."&gallerypage=".$gpage."\">".$lang[sn_allbum_select_item]."</a></span>";
  }
}

function ShowPreviousNext($id, $current_page, $numobjects, $maxperpage, $numperrow)
{
  // Task: render previous and next images for navigation if previous and next
  // page exists in (sub)-album.
  
  global $module;
  global $lang;
  global $navpath;

  if ($current_page > 1) { 
	$previous_exists = "true" ;
	$prev = $current_page - 1;
  } else {
	$previous_exists = "false" ;
  }

  if ($current_page * $maxperpage < $numobjects) {
	$next_exists = "true";
	$next = $current_page + 1;
  } else {
	$next_exists = "false" ;
  }

  // Calculate the highest page number:
  $highest = round(ceil($numobjects / $maxperpage));

  echo "<tr><td colspan=\"".$numperrow."\" align=\"center\">";
  
  if ($previous_exists == "true") {
	echo "<a href=\"index.php?option=modulemanager&module=" .$module . "&suboption=show&ID=" .$id . "&navpath=".$_GET[navpath]."&gallerypage=" .$prev . "\"><img border=\"0\" src=\"modules/sn_allbum/nav_prev_icon.gif\"></a>";
  } else {
	echo "<img border=\"0\" src=\"modules/sn_allbum/nav_dummy.gif\">";
  }
  
  $i = 1;
  echo "&nbsp;";
  while ($i <= $highest) {
    if ($i == $current_page) {
	$showi = "<font color=\"green\">[".$i."]</font>";
    } else {
	$showi = "[".$i."]";
    }
    echo "<span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module . "&suboption=show&ID=" .$id . "&navpath=".$_GET[navpath]."&gallerypage=" .$i . "\">".$showi."</a>";
    echo "&nbsp;";
    $i++;
  }
  
  if ($next_exists == "true") {
	echo "<a href=\"index.php?option=modulemanager&module=" .$module . "&suboption=show&ID=" .$id . "&navpath=".$_GET[navpath]."&gallerypage=" .$next . "\"><img border=\"0\" src=\"modules/sn_allbum/nav_next_icon.gif\"></a>"; 
  } else {
	echo "<img border=\"0\" src=\"modules/sn_allbum/nav_dummy.gif\">";
  }
  
  echo "</td></tr>";

}

function ShowCreateAlbum()
{
        global $title;
        global $module;
        global $description;
        global $lang;
        global $ID;
	global $gallerypage;
	global $navpath;

	if ( ($_GET[title] == "") OR ($_GET[title] == ".") OR ($_GET[title] == "..") OR ($_GET[description] == "") OR (strlen($_GET[description]) > 1000) OR (illegal_chars($_GET[title]))) 
	{

            echo "<form action=\"index.php\" method=\"get\">";

	    echo "<span class=\"heading\">" .$lang[sn_allbum_create_album]. "</span>";
	    
	    echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	    echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
	    echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"createalbum\">";
	    echo "<INPUT type=\"hidden\" name=\"navpath\" value=\"".$_GET[navpath]."\">";
    	    echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">"; // might be empty

	    echo "<BR><BR>";

	    if (strlen($_GET[description]) > 1000) {
		echo "<p><span class=\"text\">".$lang[sn_allbum_description_1000]."</span></p>";
	    }
	    
	    if (illegal_chars($_GET[title])) {
		echo "<p><span class=\"text\">".$lang[sn_allbum_title_illegal]."</span></p>";
	    }
	    
	    if (($_GET[title] == ".") OR ($_GET[title] == "..")) {
		echo "<p><span class=\"text\">".$lang[sn_allbum_title_like_dir]."</span></p>";
	    }
	    
	    echo "<BR><BR>";
	    echo "<table>
	      <tr>
    		<td valign=\"top\">
    		  <p><span class=\"text\">
		    " .$lang[sn_allbum_title]. ":
    		  </span></p>
    		</td>
    		<td>
    		    <p><TEXTAREA cols=\"25\" rows=\"1\" name=\"title\">" .$_GET[title]. "</TEXTAREA></p>
    		</td>
	      </tr>
	      <tr>
    		<td valign=\"top\">
    		    <p><span class=\"text\">" .$lang[sn_allbum_description]. ":</span></p>
    		</td>
    		<td>
    		    <p><TEXTAREA cols=\"50\" rows=\"5\" name=\"description\">" .$_GET[description]. "</TEXTAREA></p>
    		</td>
	      </tr>
	      <tr>
    		<td align=\"center\" colspan=\"2\">
    		    <BR>
    		    <INPUT type=\"submit\" value=\"" .$lang[sn_allbum_create_album]. "\">
    		    <BR>
    		</td>
	      </tr>
		</table></form>";
	}
	else // title and description have been entered 
	{

	    if ( ($_GET[ID] != "") AND ($_GET[ID] != "0") ) {
	      $parent = $_GET[ID]; // SUB-ALBUM
	    } else {
	      $parent = -1; // MAIN-ALBUM
	    }
            
	    // Check if album with the same title already exists:
	    if (db_GetAlbumExists($_GET[title], $parent)) {
	    
	        // Create HTML webpage:
		echo "<form action=\"index.php\" method=\"get\">";
		echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
		echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
		echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"show\">";
		if ($_GET[ID] != "") {
		    echo "<INPUT type=\"hidden\" name=\"navpath\" value=\"".$_GET[navpath]."\">";
		    echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=1>";
		    echo "<INPUT type=\"hidden\" name=\"ID\" value=\"" .$_GET[ID]. "\">";
		}
    		echo "<span class=\"heading\">" .$lang[sn_allbum_album_exists]. "</span>";
    		echo "<table>
	    	<tr>
	    	    <td valign=\"top\">
	    	        <p><span class=\"text\">
	    	        ".$lang[sn_allbum_album_exists_text]."
	    	        </span></p>
	    	    </td>
	    	</tr>
	    	<tr>
	            <td align=\"center\" colspan=\"2\">
	        	<BR>
	        	<INPUT type=\"submit\" value=\"" .$lang[sn_allbum_return]. "\">
	        	<BR>
	            </td>
	    	</tr>
	        </table></form>";
		
	    } else {
	      
	        if (($_GET[ID] != "") AND ($_GET[ID] != "0")) {
		    // Create sub-album:
		    $parentpath = db_GetPath($_GET[ID]);
	    	    $result = db_PutCreateObject('subalbum', $_GET[title], $_GET[description], str_replace("//","/",$parentpath. "/" .$_GET[title]), 'modules/sn_allbum/empty.gif', NULL, NULL, $_GET[ID], 0, 0);
		} else {
		    // Create album:
		    $arraymainalbums = db_GetContents("0");
		    $albumnum = 0;
		    foreach($arraymainalbums AS $key => $value) {
			$parentfield = db_GetParentID($value);
			if ($parentfield > $albumnum) {
			    $albumnum = $parentfield;
			}
		    }
		    $albumnum++;
	    	    $result = db_PutCreateObject('album', $_GET[title], $_GET[description], str_replace("//","/", "media/gallery/".$_GET[title]), 'modules/sn_allbum/empty.gif', NULL, NULL, $albumnum, 0, 0);
		}
		
		if ($result[0] == "ok") {
		    // javascript reloads page
		    echo "<script language='javascript'>
			  window.location = 'index.php?option=modulemanager&module=" .$module. "&suboption=show&ID=" .$result[1]. "&navpath=".$_GET[navpath].",".$_GET[ID]."&gallerypage=1'
			  </script>"; 
		    echo $lang[sn_allbum_error_redirect];
		} elseif ($result[0] == "nok") {
		    // show error message:
    		    echo "<p><span class=\"heading\">".$lang[sn_allbum_err]."</span></p>";
    		    echo "<table>
	    	    <tr>
	    		<td valign=\"top\">
	    	    	    <p><span class=\"text\">
			    ".$lang[sn_allbum_create_error]."
	    	    	    </span></p>
	    		</td>
	    	    </tr>
	    	    </table>";
		}
	    }
	
	}
  
}

function ShowAddObject()
{
    	global $module;
    	global $lang;
        global $FILES;
	global $state;
	global $ID;
	global $serverpath;
	global $dir;
	global $selectedfiles;
	global $navpath;

	if ( (!(IsSet($_GET[state]))) )
	{
            echo "<form name=\"name1\" action=\"index.php?option=modulemanager&module=" .$module. "&navpath=".$_GET[navpath]."&suboption=addobject&state=2&ID=" .$_GET[ID]. "\" method=\"post\" enctype=\"multipart/form-data\">";

	    echo "<span class=\"heading\">" .$lang[sn_allbum_add_object]. "</span><BR><BR>";
	    
	    echo "<table>
	      <tr>
    		<td valign=\"top\">
    		  <p><span class=\"text\">
		    " .$lang[sn_allbum_files]. ":
    		     </span>
		  </p>
    		</td>
    		<td>";
		   $num = db_GetNumFilesOption();
		   for ($i = 1; $i <= $num; $i++) {
		     echo "<INPUT type=\"file\" name=\"file" .$i. "\"><BR>";
		   }
		echo "
    		</td>
	      </tr>
	      <tr>
	        <td colspan=\"2\"><BR>
		    <p><span class=\"text\">".$lang[sn_allbum_or_select_files]."</span></p>
		</td>
	      </tr>
	      <tr>
	        <td width=\"30%\">&nbsp;</td>
	        <td>";
		    if (!IsSet($_GET[dir])) {
			$dir = "media/";
		    } else {
			$dir = $_GET[dir];
		    }
		    ShowDir($dir);
		echo "</td>
	      </tr>
	      <tr>
    		<td align=\"left\" colspan=\"2\">
		    <center>
    		    <INPUT type=\"submit\" value=\"" .$lang[sn_allbum_add_objects]. "\">
		    </center>
    		    <BR>
    		</td>
	      </tr>
		</table></form>";
	}
	elseif ($_GET[state] == "2")
	{
	
	    if (IsSet($_POST[selectedfiles]) or IsSet($_POST[selecteddirs])) {
	    
		// File(s) and/or Directorie(s) are located somewhere in media/, inspect 
		// $_POST[selectedfiles][i] and $_POST[selecteddirs][i] for their location.

                $copysucces = true;
		$dbsucces = array("ok","");
		$dirsucces = true;

		// process files:
		if (IsSet($_POST[selectedfiles])) {
		    foreach($_POST[selectedfiles] AS $key => $value) {
			$tmp = UseFileFromMedia($value,$_GET[ID]);
			$copysucces = $tmp[0];
			$dbsucces[0] = $tmp[1];
			$dbsucces[1] = $tmp[2];
			if (!$copysucces OR ($dbsucces[0] != "ok")) {
			    break;
			}
		    }
		}
		
		// process directories:
		if (IsSet($_POST[selecteddirs]) AND $copysucces) {
		    foreach($_POST[selecteddirs] AS $key => $value) {
			$dirsucces = UseDirFromMedia($value,$_GET[ID]);
		    }
		}

		// show page (show error messages)
		if ( $copysucces AND ($dbsucces[0] == "ok") AND $dirsucces) {
	    	    // Everything ok; load current allbum contents, last page
		    $last_page = round(ceil(count(db_GetContents($_GET[ID])) / db_GetMaxObjectsPerPage()));
		    echo "<tr><td colspan=\"2\"><script language='javascript'>
		      window.location = 'index.php?option=modulemanager&module=" .$module. "&navpath=".$_GET[navpath]."&suboption=show&ID=" .$_GET[ID]. "&gallerypage=".$last_page."'
		      </script>"; 
		    echo $lang[sn_allbum_error_redirect];
		} else {
		    echo "<span class=\"heading\">" .$lang[sn_allbum_add_object_error]. "</span><BR><BR>";
		    echo $lang[sn_allbum_add_object_error_text] . "<BR><BR>";
		    if (!$copysucces) {
			echo $lang[sn_allbum_file_copy_error_media];
		    }
		    if ($dbsucces[0] == "nok") {
			echo $lang[sn_allbum_database_error];
		    }
		    if (!$dirsucces) {
			echo "An error occured while adding a sub-album.";
		    }
		}
		
		echo "</td></tr></table>";

	    } else {
		// File(s) has(ve) been uploaded to temporary directory
	
		// Get path to main parent:
		$parents = db_GetPath($_GET[ID]);
	    
		// move files to right directory:
		$i = 1;
		$temp = "file" . "$i";
		$num = db_GetNumFilesOption();
		$succes1 = "ok";
		while ($i <= $num AND ($_FILES[$temp]['error'] == 0)) {
		    $dest = str_replace("//","/",($serverpath . "/" . $parents  . "/" . $_FILES[$temp]['name']));
		    if (file_exists($dest)) {
			$succes1 = "nok";
			$exists_error = true;
			break;
		    }
		    move_uploaded_file($_FILES[$temp]['tmp_name'],$dest);
		    if ($_FILES[$temp]['error'] != 0) {
			$succes1 = "nok";
			break;
		    }
		    // update database:
		    // todo: pdf, MS Office, OpenOffice
		    if (substr_count($_FILES[$temp]['type'],"image") != 0) {
			$type = "picture";
			$thumb = $_FILES[$temp]['name'];
		    } elseif (substr_count($_FILES[$temp]['type'],"mp3") != 0) {
			$type = "sound";
			$thumb = "modules/sn_allbum/sound.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"wav") != 0) {
			$type = "sound";
			$thumb = "modules/sn_allbum/sound.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"real") != 0) {
			$type = "sound";
			$thumb = "modules/sn_allbum/sound.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"avi") != 0) {
			$type = "movie";
			$thumb = "modules/sn_allbum/movie.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"rm") != 0) {
			$type = "movie";
			$thumb = "modules/sn_allbum/movie.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"mpg") != 0) {
			$type = "movie";
			$thumb = "modules/sn_allbum/movie.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"mpeg") != 0) {
			$type = "movie";
			$thumb = "modules/sn_allbum/movie.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"divx") != 0) {
			$type = "movie";
			$thumb = "modules/sn_allbum/movie.gif";
		    } elseif (substr_count($_FILES[$temp]['type'],"wmv") != 0) {
			$type = "movie";
			$thumb = "modules/sn_allbum/movie.gif";
		    } else {
			$type = "unknown";
			$thumb = "modules/sn_allbum/unknown.gif";
		    }
			$obj = $_FILES[$temp]['name'];
			$org = $_FILES[$temp]['name'];
		    $title = $_FILES[$temp]['name'];
		    $description = NULL;
		    $space = 0;
		    $hidden = 0;
		    $path = str_replace("//","/",$parents. "/");
		    $parent_ID = $_GET[ID];
		    $succes2 = db_PutCreateObject($type,$title,$description,$path,$thumb,$obj,$org,$parent_ID,$space,$hidden);
		    if ($succes2[0] == "nok") {
			break;
		    }
		    $i++;
		    $temp = "file" . "$i";
		}
		// show page
		if ( ($succes1 == "ok") AND ($succes2[0] == "ok")) {
	    	    // load current allbum contents, last page
		    $last_page = round(ceil(count(db_GetContents($_GET[ID])) / db_GetMaxObjectsPerPage()));
		    echo "<tr><td colspan=\"2\"><script language='javascript'>
		      window.location = 'index.php?option=modulemanager&module=" .$module. "&navpath=".$_GET[navpath]."&suboption=show&ID=" .$_GET[ID]. "&gallerypage=".$last_page."'
		      </script>";
		    echo $lang[sn_allbum_error_redirect];
		} else {
		    echo "<span class=\"heading\">" .$lang[sn_allbum_add_object_error]. "</span><BR><BR>";
		    echo "<table>
	    	    <tr>
	        	<td valign=\"top\" colspan=\"2\">
	        	    <p><span class=\"text\">
	    		    ".$lang[sn_allbum_add_object_error_text]."
	        	    </span></p>
	        	</td>
	    	    </tr>";
		    if ($succes2[0] == "nok") {
	    	    	// update database error
		    }
		    if ($succes1 == "nok") {
		    	// file upload error, database action not taken
		    	echo "<tr><td colspan=\"2\"><span class=\"text\">".$lang[sn_allbum_file_upload_error]."</span></td></tr>";
		    	echo "<tr><td colspan=\"2\"><span class=\"text\">";
		    	$i = 1;
		    	$temp = "file". "$i";
		    	while ($i <= $num AND $_FILES[$temp]['error'] == 0) {
				$i++;
				$temp = "file" . "$i";
		    	}
		    	if ($exists_error) {
				echo $lang[sn_allbum_error9];
			} elseif ($_FILES[$temp]['error'] == 0) {
				echo $lang[sn_allbum_error0];
		    	} elseif ($_FILES[$temp]['error'] == 1) {
				echo $lang[sn_allbum_error1];
		    	} elseif ($_FILES[$temp]['error'] == 2) {
				echo $lang[sn_allbum_error2];
		    	} elseif ($_FILES[$temp]['error'] == 3) {
				echo $lang[sn_allbum_error3];
		    	} elseif ($_FILES['file . $i']['error'] == 4) {
				echo $lang[sn_allbum_error4];
		    	} else {
				echo $lang[sn_allbum_error];
		    	}
			echo "</span>"; 
		    }
		}
		echo "</td></tr></table>";
	    }
	}
}

function UseFileFromMedia($file,$parentID) 
{
  // Task: puts file $file in allbum with id $parentID

  global $serverpath;

  $parents = db_GetPath($parentID);

  // copy file to it's destination
  $filename = explode("/",$file);
  $filename = array_reverse($filename);
  $filename = $filename[0];
  $dest = str_replace("//","/",($serverpath . "/" . $parents  . "/" . $filename));
  $src = $file;
  if (file_exists($dest)) {
	$copysucces = false;
  } else {
	$copysucces = copy($src,$dest);
  }
		    
  // update database if copy was succesfull
  if ($copysucces) {
	// todo: pdf, MS Office, OpenOffice
	$fileext = explode(".",$filename);
	$fileext = array_reverse($fileext);
	$fileext = strtolower($fileext[0]);
	if (($fileext == "jpg") OR ($fileext == "gif") OR ($fileext == "jpeg")) {
	    $type = "picture";
	    $thumb = $filename;
	} elseif (($fileext == "mp3") OR ($fileext == "wav") OR ($fileext == "real")) {
	    $type = "sound";
	    $thumb = "modules/sn_allbum/sound.gif";
	} elseif (($fileext == "wmv") OR ($fileext == "rm") OR ($fileext == "mpg") OR ($fileext == "mpeg") OR ($fileext == "avi")) {
	    $type = "movie";
	    $thumb = "modules/sn_allbum/movie.gif";
	} else {
	    $type = "unknown";
	    $thumb = "modules/sn_allbum/unknown.gif";
	}
	$title = $filename;
	$obj = $filename;
	$org = $filename;
	$description = NULL;
	$space = 0;
	$hidden = 0;
	$path = str_replace("//","/",$parents. "/");
	$parent_ID = $parentID;
	$dbsucces = db_PutCreateObject($type,$title,$description,$path,$thumb,$obj,$org,$parent_ID,$space,$hidden);
  }
  return array($copysucces,$dbsucces[0],$dbsucces[1]);
}


function UseDirFromMedia($dir,$parentID)
{
  // Task: inside (sub-)album with id $parentID, a sub-album with title
  // '$dir' is created. Inside this sub-album, all files and directories
  // inside directory $dir are added. Using this function recursively.

  $parents = db_GetPath($parentID);
  
  $result = true;

  // Check if a sub-album with title $dir already exists in parent album
    $path2 = explode("/",$dir);
    $path2 = array_reverse($path2);
    $path2 = $path2[0];
  if (db_GetAlbumExists($path2,$parentID)) {
    echo "Album with title ".$path2." already exists. Will not add this directory nor it contents.";
    $result = false;
  } else {
  
    // create sub-album
    $type = "subalbum";
    $thumb = "modules/sn_allbum/empty.gif";
    $org = NULL;
    $obj = NULL;
    $description = NULL;
    $space = 0;
    $hidden = 0;
    $title = $path2;
    $path = str_replace("//","/",$parents. "/" .$path2);
    $parent_ID = $parentID;
    $succes = db_PutCreateObject($type,$title,$description,$path,$thumb,$obj,$org,$parent_ID,$space,$hidden);
    if ($succes[0] != "ok") {
	$result = false;
    }
    
    // get list of contents from $dir
    $list = array();
    $handle = opendir($dir);
    while (false !== ($item = readdir($handle))) {
	if ($item != "." && $item != "..") {
	    array_push($list,$item);
	}
    }
    
    // foreach in list:
    //   if file: UseFileFromMedia, if dir: UseDirFromMedia,
    foreach($list AS $key => $value) {
        $value2 = str_replace("//","/",$dir. "/" .$value);
	if (is_dir($value2) === true) {
	    UseDirFromMedia($value2,$succes[1]);
	} elseif (is_file($value2) === true) {
	    UseFileFromMedia($value2,$succes[1]);
	}
    }

  }
  return $result;
  
}

function ShowDir($dir)
{
  // Task: show contents of directory $dir, make it possible
  // to select files and/or directories. Do not show media/gallery.
  // CAUTION: this function depends on function ShowAddObject()!
  
  global $module;
  global $id;
  global $option;
  global $lang;

  // echo some javascript for a 'toggle all' button:
  echo "<script language=\"JavaScript\">
	<!--
	function doselectAll(theBox) {
	  State = theBox.checked;
	  elm=theBox.form.elements;
	  for(i=0 ; i < elm.length ; i++) {
	    if(elm[i].type==\"checkbox\") {
	      elm[i].checked=State;
	    }
	  }
	}
	-->
	</script>";
  
  $dp = opendir($dir);
  echo "<BR><span class=\"link\">".$dir."</span><BR><BR>";

  echo "<input type=\"checkbox\" id=\"SelectAll\" name=\"SelectAll\" onClick=\"doselectAll(this)\"><span class=\"text\">".$lang[sn_allbum_toggle]."</span><BR><BR>";

  $dirs = array();
  $files = array();
  while (false !== ($file = readdir($dp))) {
    if (is_dir(str_replace("//","/",$dir."/".$file))) {
        if (($file != ".") AND ($file != "..")) {
	    if ( !((($dir == "media") OR ($dir == "media/")) AND ($file == "gallery")) ) {
		array_push($dirs,$file); 
	    }
	}
    } else {
        array_push($files,$file);
    }
  }
  closedir($dp);
  if (($dir != "media") AND ($dir != "media/")) {
    $dirname = explode("/",$dir);
    array_pop($dirname);
    $dirname = implode("/",$dirname);
    echo "<img src=\"graphics/folder.gif\"><span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=addobject&dir=".$dirname."&ID=" .$_GET[ID]."\">..</a></span><BR>";  
  }
  
  foreach ($dirs AS $key => $value) {
    $dirname = str_replace("//","/",$dir . "/" . $value);
    echo "<img src=\"graphics/folder.gif\"><INPUT TYPE=\"checkbox\" id=\"".$value."\" NAME=\"selecteddirs[]\" VALUE=\"".$dirname."\"><span class=\"link\"><a href=\"index.php?option=modulemanager&module=" .$module. "&suboption=addobject&dir=".$dirname."&ID=" .$_GET[ID]."\">".$value."</a></span><BR>";
  }
  
  foreach ($files AS $key => $value) {
    $filefullpath = str_replace("//","/",$dir . "/" . $value);
    echo "<img src=\"graphics/document.gif\"><span class=\"text\"><INPUT TYPE=\"checkbox\" id=\"".$value."\" NAME=\"selectedfiles[]\" VALUE=\"".$filefullpath."\">".$value."</span><BR>";
  }
  echo "<BR>";
}

function ShowConfig()
{
    global $module;
    global $lang;
    global $state;

    if (!IsSet($_GET[state]))
    {
	echo "<form action=\"index.php\" method=\"get\">";
        echo "<span class=\"heading\">" .$lang[sn_allbum_configuration]. "</span>";
	echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
        echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
        echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"config\">";
	echo "<INPUT type=\"hidden\" name=\"state\" value=\"save\">";

	echo "<table>";

	// Get (config_key, config_value, description) for each config option
	$config2d = db_GetConfigOptions();
	
	foreach($config2d as $value) {
	    echo "<tr>
	            <td width=\"50%\" valign=\"top\">
		      <p><span class=\"text\">" .$lang["sn_allbum_" .$value[0]]. "</span></p>
		    </td>
	            <td width=\"50%\" valign=\"top\">
		      <INPUT type=\"text\" size=\"35\" name=\"" .$value[0]. "\" value=\"" .$value[1]. "\">
		    </td>
		  </tr>
		  <tr><td colspan=\"2\">&nbsp;</td></tr>";
	}
    
        echo "<tr>
    		<td colspan=\"2\">
		    <BR><BR>
		    <center>
    		    <INPUT type=\"submit\" value=\"" .$lang[sn_allbum_save_configuration]. "\">
		    </center>
		    <BR><BR>
    		</td>
	      </tr>
	      </table></form>";
    }
    elseif ($_GET[state] == "save") {
	// get the array again
	$config2d = db_GetConfigOptions();
	
	// make all config_keys global and update the database
	foreach($config2d as $value) {
	    global $value0;
	    $value0 = $value[0];
	    db_PutConfigOption($value[0], $_GET[$value0]);
	}
	
	// render HTML page
	echo "<p><span class=\"heading\">" .$lang[sn_allbum_configuration_saved]. "</span></p>";
	echo "<p><span class=\"text\">" .$lang[sn_allbum_configuration_saved_text]. "</span></p>";
    }    

}

function ShowNavPath($navpath)
{
  // Task: show navigation path containing links to object
  // id's in $navpath. $navpath is a list, were items are
  // seperated by a ','.
  
  global $lang;
  
  // convert to an array and remove empty elements:
  $navpath = explode(",",$navpath);
  $navpath = array_clean($navpath,"");
  
  // start output:
  echo "<p><span class=\"link\">".$lang[sn_allbum_return_to];
  
  // show link to main page:
  global $module;
  echo "<a href=\"index.php?option=modulemanager&module=".$module."\">Main</a>";
  
  // show other links:
  if (IsSet($navpath)) {
    foreach($navpath AS $key => $value) {
	$title = db_GetTitle($value);
	$newnavpath = $navpath;
	$newnavpath = array_clean($newnavpath,"");
	$tmp = array();
	for ($i = 0; $i == $key-1; $i++) {
	    array_push($tmp,$newnavpath[$i]);
	}
	if ($tmp != "") {
	    $newnavpath = implode(",",$tmp);
	}
	echo " -> <a href=\"index.php?option=modulemanager&module=".$module."&navpath=".$newnavpath."&suboption=show&ID=".$value."&gallerypage=1\">".$title."</a>";
    }
  }
  
  // end output:
  echo "</span></p>";
  
}

function ShowMove()
{
    // Task: show a page with a list of items that will be moved. Below that,
    // let the user select a (sub-)album where the items will be moved to.
    // At the bottom a move and cancel button. 
    // Move the selected objects.
    
    global $ID;
    global $gallerypage;
    global $lang;
    global $module;
    global $ID3;
    global $candidate;
    global $move;

    $contents = explode(",",$_GET[ID3]);
    $contents = array_clean($contents,"");
    
    foreach ($contents AS $key => $value) {
	$type = db_GetType($value);
	if (($type == "subalbum") or ($type == "album")) {
	    $contents = array_clean($contents,$value);
	}
    }

    // Check if the list has become empty (only (sub-)albums have been selected):
    if (!IsSet($contents[0])) {

	echo "<form action=\"index.php\" method=\"get\">";

	echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
	echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"show\">";
    	echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">";
    	echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"".$_GET[gallerypage]."\">";

	echo "<p><span class=\"heading\">" .$lang[sn_allbum_move_heading]. "</span></p>";

	echo "<table>";
	echo "<tr><td colspan=\"2\"><p><span class=\"text\">" .$lang[sn_allbum_move_empty]. "</span></p></td></tr>";
	echo "<tr><td colspan=\"2\"><p><BR><span class=\"text\"><INPUT type=\"submit\" value=\"".$lang[sn_allbum_return]."\"</span></p></td></tr>";
	echo "</table>";

    } elseif ((!IsSet($_GET[move])) OR (!IsSet($_GET[candidate])) OR ($_GET[candidate]=="")) {
    
	// Show heading and text:
	echo "<p><span class=\"heading\">" .$lang[sn_allbum_move_heading]. "</span></p>";
	
	if (IsSet($_GET[move]) AND ((!IsSet($_GET[candidate])) OR ($_GET[candidate]==""))) {
	    echo "<p><span class=\"text\"><font color=\"orange\">" .$lang[sn_allbum_move_not_main]. "</font></span></p>";
	}
	
	echo "<p><span class=\"text\">" .$lang[sn_allbum_move_text]. "</span></p>";
    
	// List objects that will be moved:
	echo "<UL>";
	foreach ($contents AS $key => $value) {
	    echo "<LI><span class=\"text\">";
	    echo db_GetTitle($value);
	    echo " (" .db_GetType($value). ")";
	    echo "</LI></span>";
	}
	echo "</UL>";
	
	// Show second text:
	echo "<p><span class=\"text\">" .$lang[sn_allbum_move_text2]. "</span></p>";
	
	// Show requested destination candidate:
	if ((!IsSet($_GET[candidate])) OR ($_GET[candidate] == "")) {
	    $candidate = 0;
	    $candidate_title = $lang[sn_allbum_main];
	} else {
	    $candidate = $_GET[candidate];
	    $candidate_title = $lang[sn_allbum_main];
	    $path = db_GetPath($candidate);
	    $path = explode("/",$path);
	    foreach($path AS $key => $value) {
		if (($value == "media") OR ($value == "gallery")) {
		    // skip
		} else {
		    $candidate_title = $candidate_title ." -> ".$value;
		}
	    }
	}
	echo "<UL><span class=\"text\"><b>" .$candidate_title. "</b></span><BR><BR>";
	$candidate_contents = db_GetContents($candidate);
	if ($candidate != 0) {
	    echo "<LI><span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&suboption=move&ID3=".$_GET[ID3]."&candidate=".db_GetParentID($candidate)."\">".$lang[sn_allbum_return]."</a></span></LI>";
	}
	foreach ($candidate_contents AS $key => $value) {
	    $type = db_GetType($value);
	    if (($type == "album") OR ($type == "subalbum")) {
		echo "<LI><span class=\"text\"><a href=\"index.php?option=modulemanager&module=".$module."&suboption=move&ID3=".$_GET[ID3]."&ID=".$_GET[ID]."&gallerypage=".$_GET[gallerypage]."&candidate=".$value."\">".db_GetTitle($value)."</a></span></LI>";
    	    }
	}
	echo "</UL>";

	echo "<form action=\"index.php\" method=\"get\">";

	echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
	echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"move\">";
	echo "<INPUT type=\"hidden\" name=\"candidate\" value=\"".$_GET[candidate]."\">";
	echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">";
	echo "<INPUT type=\"hidden\" name=\"ID3\" value=\"".implode(",",$contents)."\">";
	echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"".$_GET[gallerypage]."\">";
	
	echo "<INPUT type=\"submit\" name=\"move\" value=\"".$lang[sn_allbum_move]."\">";

    } elseif (IsSet($_GET[move])) {
	
	// what objects must be moved?
	$move_objects = array_clean(explode(",", $_GET[ID3]),"");
	
	// Let's move them!
	$result[0] = "ok";
	foreach($move_objects AS $key => $value) {
	    $result = MoveObject($value,$_GET[candidate]);
	    if ($result[0] == "nok") {
		echo "<p><span class=\"heading\">".$lang[sn_allbum_move_error]."</span></p>";
		echo "<p><span class=\"text\">" .$lang[sn_allbum_move_error_text]."</span></p>";
		echo "<p><span class=\"text\">" .$result[1]."</span></p>";
		break;
	    }
	}
	if ($result[0] == "ok") {
	    echo $lang[sn_allbum_no_errors];
	    echo "<script language='javascript'>
	      window.location = 'index.php?option=modulemanager&module=" .$module. "&suboption=show&ID=" .$_GET[ID]. "&gallerypage=1'
	      </script>";
	    echo $lang[sn_allbum_error_redirect];
	}
    }
}

function ShowOrderSub()
{
    	global $module;
    	global $lang;
	global $state;
	global $ID;
	global $navpath;

	// if a new order has been chosen, verify if it is a valid one:
	
	$valid = true;
	
	if ( (IsSet($_GET[state])) AND ($_GET[state] == 2) ) {
	    $order = array();
	    $keys = array('option','module','suboption','state','ID','navpath','gallerypage');
	    foreach($_GET AS $key => $value) {
		if (!in_array($key,$keys)) {
		    array_push($order,$value);
		} 
	    }
	    sort($order);
	    $i = 0;
	    while ($i < count($order)) {
		if ($order[$i] != $i+1) {
		    $valid = false;
		}
		$i++;
	    }
	}

	if ( (!(IsSet($_GET[state]))) OR (!$valid) )
	{

	    echo "<form action=\"index.php\" method=\"get\">";

	    echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	    echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
    	    echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"ordersub\">";
	    echo "<INPUT type=\"hidden\" name=\"state\" value=\"2\">";
	    echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">";
	    echo "<INPUT type=\"hidden\" name=\"navpath\" value=\"".$_GET[navpath]."\">";
	    echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"1\">";

	    echo "<span class=\"heading\">" .$lang[sn_allbum_order_album]. "</span><BR><BR>";
	    
	    if (!$valid) {
		echo "<p><span class=\"text\"><font color=\"orange\">".$lang[sn_allbum_order_invalid]."</font></span></p>";
	    }
	    
	    echo "<table>
	      <tr>
    		<td>
    		  <p><span class=\"text\">
		    " .$lang[sn_allbum_order_album_text]. ":
    		     </span>
		  </p><BR>
    		</td>
	      </tr>
	      <tr>
    		<td>";
		    $contents = db_GetContents($_GET[ID]);
		    foreach($contents AS $key => $value) {
			echo "<SELECT name=\"".$value."\">";
			$i = 1;
			if (IsSet($_GET[$value])) {
			    while ($i <= count($contents)) {
				echo "<OPTION";
				global ${$value};
				if ($i == $_GET[$value]) {
				    echo " selected";
				}
				echo " value=\"".$i."\"";
				echo "\">".$i."</option>";
				$i++;
			    }
			} else {
			    while ($i <= count($contents)) {
				echo "<OPTION";
				if ($i == $key+1) {
				    echo " selected";
				}
				echo " value=\"".$i."\"";
    				echo "\">".$i."</OPTION>";
				$i++;
			    }
			}
			echo "</SELECT>&nbsp;&nbsp;";
			echo db_GetTitle($value);
			echo "<BR>";
		    }
    		echo "</td>
	      </tr>
	      <tr>
    		<td align=\"center\">
		    <BR>
    		    <INPUT type=\"submit\" value=\"" .$lang[sn_allbum_order]. "\">
    		    <BR>
    		</td>
	      </tr>
		</table></form>";
	}
	elseif (($_GET[state] == "2") AND $valid)
	{
	    // new orders have been entered and are valid; now reorder items.
	    $keys = array('option','module','suboption','state','ID','navpath','gallerypage');
	    $order = array();
	    foreach($_GET AS $key => $value) {
	        global ${$key};
		if (!in_array($key,$keys)) {
		    $order[$key] = $_GET[$key];
		} 
	    }
	    asort($order);
	    $string;
	    foreach($order AS $key => $value) {
		$string = $string . $key;
		if ($value != (count($order))) {
		    $string = $string . ",";
		}
	    }
	    db_PutChildren($_GET[ID],$string);
	    
	    echo $lang[sn_allbum_no_errors];
	    echo "<script language='javascript'>
	      window.location = 'index.php?option=modulemanager&module=" .$module. "&suboption=show&navpath=".$_GET[navpath]."&ID=" .$_GET[ID]. "&gallerypage=".$_GET[gallerypage]."'
	      </script>";
	    echo $lang[sn_allbum_error_redirect];

	}
}

function ShowOrderMain()
{
    	global $module;
    	global $lang;
	global $state;
	global $ID;
	global $gallerypage;

	$valid = true;
	
	if ( (IsSet($_GET[state])) AND ($_GET[state] == 2) ) {
	    $order = array();
	    $keys = array('option','module','suboption','state','ID','gallerypage');
	    foreach($_GET AS $key => $value) {
		if (!in_array($key,$keys)) {
		    $order[$key] = $value;
		} 
	    }
	    asort($order);
	    $i = 0;
	    foreach($order AS $key => $value) {
		if ($order[$key] != $i+1) {
		    $valid = false;
		    break;
		}
		$i++;
	    }
	}
	
	if ( !(IsSet($_GET[state])) OR (!$valid) )
	{

	    echo "<form action=\"index.php\" method=\"get\">";

	    echo "<INPUT type=\"hidden\" name=\"option\" value=\"modulemanager\">";
	    echo "<INPUT type=\"hidden\" name=\"module\" value=\"" .$module. "\">";
    	    echo "<INPUT type=\"hidden\" name=\"suboption\" value=\"ordermain\">";
	    echo "<INPUT type=\"hidden\" name=\"state\" value=\"2\">";
	    echo "<INPUT type=\"hidden\" name=\"ID\" value=\"".$_GET[ID]."\">";
	    echo "<INPUT type=\"hidden\" name=\"gallerypage\" value=\"1\">";

	    echo "<span class=\"heading\">" .$lang[sn_allbum_order_album]. "</span><BR><BR>";
	    
	    if (!$valid) {
		echo "<p><span class=\"text\"><font color=\"orange\">".$lang[sn_allbum_order_invalid]."</font></span></p>";
	    }
	    
	    echo "<table>
	      <tr>
    		<td>
    		  <p><span class=\"text\">
		    " .$lang[sn_allbum_order_album_text]. ":
    		     </span>
		  </p><BR>
    		</td>
	      </tr>
	      <tr>
    		<td>";
		    $contents = db_GetContents(0);
		    $albumparentarray = array();
		    foreach($contents AS $key => $value) {
			$albumparentarray[$value] = db_GetParentID($value);
		    }
		    asort($albumparentarray);
		    foreach($albumparentarray AS $key => $value) {
			if (!IsSet($_GET[$key])) {
			    echo "<SELECT name=\"".$key."\">";
			    $i = 1;
			    while ($i <= count($albumparentarray)) {
				echo "<OPTION";
				if ($i == $value) {
				    echo " selected";
				}
				echo " value=\"".$i."\">";
				echo $i."</OPTION>";
				$i++;
			    }
			    echo "</SELECT>&nbsp;&nbsp;";
			    echo db_GetTitle($key);
			    echo "<BR>";
			} else {
			    echo "<SELECT name=\"".$key."\">";
			    $i = 1;
			    while ($i <= count($albumparentarray)) {
				echo "<OPTION";
				global ${$key};
				if ($i == $_GET[$key]) {
				    echo " selected";
				}
				echo " value=\"".$i."\">";
				echo $i."</OPTION>";
				$i++;
			    }
			    echo "</SELECT>&nbsp;&nbsp;";
			    echo db_GetTitle($key);
			    echo "<BR>";
			}
		    }
    		echo "</td>
	      </tr>
	      <tr>
    		<td align=\"center\">
		    <BR>
    		    <INPUT type=\"submit\" value=\"" .$lang[sn_allbum_order]. "\">
    		    <BR>
    		</td>
	      </tr>
		</table></form>";
	}
	elseif ( ($_GET[state] == "2") AND $valid)
	{
	    // new orders have been entered and are valid; now reorder items.
	    foreach ($order AS $key => $value) {
		db_PutParents($key,$value);
	    }

	    echo $lang[sn_allbum_no_errors];
	    echo "<script language='javascript'>
	      window.location = 'index.php?option=modulemanager&module=" .$module. "&suboption=show&navpath=".$_GET[navpath]."&ID=" .$_GET[ID]. "&gallerypage=".$_GET[gallerypage]."'
	      </script>";
	    echo $lang[sn_allbum_error_redirect];

	}
}

?>
